-module(bevezeto).
-export([fac/1, sum/1, append/2, revapp/2, faci/1]).
%-compile(export_all).
-author('kapolnai@iit.bme.hu, hanak@emt.bme.hu').
-vsn('$LastChangedDate: 2019-10-29 21:47:55 +0100 (k, 29 okt 2019) $$').

-spec fac(N::integer()) -> F::integer().
% F = N! (F az N faktoriálisa).
fac(0) -> 1;
fac(N) -> N * fac(N-1).

-spec sum(Ls::[number()]) -> S::number().
% Az Ls lista elemeinek összege S.
sum([]) -> 0;
sum(L)  -> H = hd(L), T = tl(L), H + sum(T).

-spec append(Ls1::[term()], Ls2::[term()]) -> Ls::[term()].
%% Ls az Ls1 elemeinek az Ls2 elé fűzésével előálló lista.
append([], Ls2) -> Ls2;
append(Ls1, Ls2) -> [hd(Ls1)|append(tl(Ls1), Ls2)].

-spec revapp(Ls1::[term()], Ls2::[term()]) -> Ls::[term()].
%% Ls a megfordított Ls1 elemeinek az Ls2 elé fűzésével előálló lista.
revapp([], Ls2) -> Ls2;
revapp(Ls1, Ls2) -> revapp(tl(Ls1), [hd(Ls1)|Ls2]).

-spec faci(N::integer()) -> F::integer().
% F = N! (F az N faktoriálisa).
faci(N) -> faci(N, 1).

-spec faci(N::integer(), R::integer()) -> F::integer().
% F = R*N! (F az N faktoriálisának R-szerese).
faci(0, R) -> R;
faci(N, R) -> faci(N-1, N*R).
