-module(lcomp).
%-compile(export_all).
-export([pitag/1, elofordul2/2, qsort/1, perms/1]).
-author('kapolnai@iit.bme.hu, hanak@emt.bme.hu').
-vsn('$LastChangedDate: 2019-10-29 21:47:55 +0100 (k, 29 okt 2019) $$').

-spec pitag(N::integer()) -> Ps::[{integer(),integer(),integer()}].
% Ps olyan pitagoraszi számhármasok listája, melyek összege legfeljebb N.
pitag(N) ->
    L = lists:seq(1,N),
    [{A,B,C} || A <- L, B <- L, C <- L,
		A+B+C =< N,
		A*A+B*B =:= C*C].

-spec elofordul2(E::term(), Ls::[term()]) -> N::integer().
% E elem az Ls listában N-szer fordul elő.
elofordul2(Elem, L) ->
    length([X || X <- L, X=:=Elem]).

-spec qsort(Us::[term()]) -> Ss::[term()].
% Az Us lista elemeinek monoton növekedő listája Ss.
qsort([]) ->
    [];
qsort([Pivot|Tail]) ->
    qsort([X || X <- Tail, X < Pivot])
	++ [Pivot] ++
	qsort([X || X <- Tail, X >= Pivot]).

-spec perms(Xs::[term()]) -> Zss::[[term()]].
% Az Xs lista elemeinek összes permutációját tartalmazó lista Zss.
perms([]) ->
    [[]];
perms(L) ->
    [[H|T] || H <- L, T <- perms(L--[H])].
